import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/base/provider/provider_manager.dart';
import 'package:flutter_mylibrary/http/exception/http_error.dart';
import '../base_view_state.dart';


abstract class BaseViewStateProviderController with ChangeNotifier, BaseViewState {

  set viewState(ViewState viewState) {
    this.viewState = viewState;
    notifyListeners();
  }


  void setIdle() {
    viewState = ViewState.idle;
    isInit = true;
  }

  void setBusy() {
    viewState = ViewState.busy;
  }


  void setError(HttpError httpError) {
    viewState = ViewState.error;
  }



  @override
  void notifyListeners() {
    if (!disposed) {
      super.notifyListeners();
    }
  }

  @override
  void dispose() {
    disposed = true;
    refreshController.dispose();
    ProviderManager().remove(controller: this);
    super.dispose();
  }

}




