import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/flutter_mylibrary.dart';
import 'package:flutter_mylibrary/utils/utils.dart';
import 'package:flutter_mylibrary/widget/video/video_control_widget.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import 'package:video_player/video_player.dart';
import 'easy_video_contrller.dart';

class VideoWidget extends StatelessWidget{


  @override
  Widget build(BuildContext context) {
    EasyVideoController easyVideoPlayerController = EasyVideoController.of(context);

    if(isEmpty(easyVideoPlayerController)){
      return buildText('请先初始化你的EasyVideoPlayerController');
    }

    EasyVideoSizeType easyVideoSizeType = easyVideoPlayerController.easyVideoSizeType??EasyVideoSizeType.SCREEN_TYPE_DEFAULT;

    return ValueListenableBuilder<double>(
        valueListenable: easyVideoPlayerController.videoAspectRatioNotifier,
        builder: (_, videoAspectRatio, __){
          if(easyVideoPlayerController.isFullScreen){
            return Scaffold(
                resizeToAvoidBottomInset: false,
                body: _buildVideo(easyVideoPlayerController)
            );
          }else{
            return easyVideoSizeType == EasyVideoSizeType.SCREEN_MATCH_FULL? SizedBox(
              width: double.infinity,
              height: double.infinity,
              child: _buildVideo(easyVideoPlayerController),
            ) : videoAspectRatio == 0? Container(
              color: Colors.black,
            ): AspectRatio(
              aspectRatio: videoAspectRatio,
              child: _buildVideo(easyVideoPlayerController),
            );
          }
        }
    );
  }



  ///Video组件
  Widget _buildVideo(EasyVideoController easyVideoPlayerController){
    return Container(
      color: Colors.black,
      child: Stack(
        children: [
          ValueListenableBuilder<VideoPlayerController>(
              valueListenable: easyVideoPlayerController.videoPlayerControllerNotifier,
              builder: (_, videoPlayerController, __){
                return VideoPlayer(videoPlayerController);
              }
          ),
          EasyVideoControllerProvider(
              controller: easyVideoPlayerController,
              child: VideoControlWidget()
          )
        ],
      ),
    );
  }

}